1
0

x-ui.sh 21 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. #Add some basic function here
  7. function LOGD() {
  8. echo -e "${yellow}[DEG] $* ${plain}"
  9. }
  10. function LOGE() {
  11. echo -e "${red}[ERR] $* ${plain}"
  12. }
  13. function LOGI() {
  14. echo -e "${green}[INF] $* ${plain}"
  15. }
  16. # check root
  17. [[ $EUID -ne 0 ]] && LOGE "ERROR: You must be root to run this script! \n" && exit 1
  18. # Check OS and set release variable
  19. if [[ -f /etc/os-release ]]; then
  20. source /etc/os-release
  21. release=$ID
  22. elif [[ -f /usr/lib/os-release ]]; then
  23. source /usr/lib/os-release
  24. release=$ID
  25. else
  26. echo "Failed to check the system OS, please contact the author!" >&2
  27. exit 1
  28. fi
  29. echo "The OS release is: $release"
  30. os_version=""
  31. os_version=$(grep -i version_id /etc/os-release | cut -d \" -f2 | cut -d . -f1)
  32. if [[ "${release}" == "centos" ]]; then
  33. if [[ ${os_version} -lt 8 ]]; then
  34. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  35. fi
  36. elif [[ "${release}" == "ubuntu" ]]; then
  37. if [[ ${os_version} -lt 20 ]]; then
  38. echo -e "${red}please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  39. fi
  40. elif [[ "${release}" == "fedora" ]]; then
  41. if [[ ${os_version} -lt 36 ]]; then
  42. echo -e "${red}please use Fedora 36 or higher version!${plain}\n" && exit 1
  43. fi
  44. elif [[ "${release}" == "debian" ]]; then
  45. if [[ ${os_version} -lt 10 ]]; then
  46. echo -e "${red} Please use Debian 10 or higher ${plain}\n" && exit 1
  47. fi
  48. fi
  49. confirm() {
  50. if [[ $# > 1 ]]; then
  51. echo && read -p "$1 [Default$2]: " temp
  52. if [[ x"${temp}" == x"" ]]; then
  53. temp=$2
  54. fi
  55. else
  56. read -p "$1 [y/n]: " temp
  57. fi
  58. if [[ x"${temp}" == x"y" || x"${temp}" == x"Y" ]]; then
  59. return 0
  60. else
  61. return 1
  62. fi
  63. }
  64. confirm_restart() {
  65. confirm "Restart the panel, Attention: Restarting the panel will also restart xray" "y"
  66. if [[ $? == 0 ]]; then
  67. restart
  68. else
  69. show_menu
  70. fi
  71. }
  72. before_show_menu() {
  73. echo && echo -n -e "${yellow}Press enter to return to the main menu: ${plain}" && read temp
  74. show_menu
  75. }
  76. install() {
  77. bash <(curl -Ls https://raw.githubusercontent.com/MHSanaei/3x-ui/main/install.sh)
  78. if [[ $? == 0 ]]; then
  79. if [[ $# == 0 ]]; then
  80. start
  81. else
  82. start 0
  83. fi
  84. fi
  85. }
  86. update() {
  87. confirm "This function will forcefully reinstall the latest version, and the data will not be lost. Do you want to continue?" "n"
  88. if [[ $? != 0 ]]; then
  89. LOGE "Cancelled"
  90. if [[ $# == 0 ]]; then
  91. before_show_menu
  92. fi
  93. return 0
  94. fi
  95. bash <(curl -Ls https://raw.githubusercontent.com/MHSanaei/3x-ui/main/install.sh)
  96. if [[ $? == 0 ]]; then
  97. LOGI "Update is complete, Panel has automatically restarted "
  98. exit 0
  99. fi
  100. }
  101. uninstall() {
  102. confirm "Are you sure you want to uninstall the panel? xray will also uninstalled!" "n"
  103. if [[ $? != 0 ]]; then
  104. if [[ $# == 0 ]]; then
  105. show_menu
  106. fi
  107. return 0
  108. fi
  109. systemctl stop x-ui
  110. systemctl disable x-ui
  111. rm /etc/systemd/system/x-ui.service -f
  112. systemctl daemon-reload
  113. systemctl reset-failed
  114. rm /etc/x-ui/ -rf
  115. rm /usr/local/x-ui/ -rf
  116. echo ""
  117. echo -e "Uninstalled Successfully,If you want to remove this script,then after exiting the script run ${green}rm /usr/bin/x-ui -f${plain} to delete it."
  118. echo ""
  119. if [[ $# == 0 ]]; then
  120. before_show_menu
  121. fi
  122. }
  123. reset_user() {
  124. confirm "Reset your username and password to admin?" "n"
  125. if [[ $? != 0 ]]; then
  126. if [[ $# == 0 ]]; then
  127. show_menu
  128. fi
  129. return 0
  130. fi
  131. /usr/local/x-ui/x-ui setting -username admin -password admin
  132. echo -e "Username and password have been reset to ${green}admin${plain},Please restart the panel now."
  133. confirm_restart
  134. }
  135. reset_config() {
  136. confirm "Are you sure you want to reset all panel settings,Account data will not be lost,Username and password will not change" "n"
  137. if [[ $? != 0 ]]; then
  138. if [[ $# == 0 ]]; then
  139. show_menu
  140. fi
  141. return 0
  142. fi
  143. /usr/local/x-ui/x-ui setting -reset
  144. echo -e "All panel settings have been reset to default,Please restart the panel now,and use the default ${green}2053${plain} Port to Access the web Panel"
  145. confirm_restart
  146. }
  147. check_config() {
  148. info=$(/usr/local/x-ui/x-ui setting -show true)
  149. if [[ $? != 0 ]]; then
  150. LOGE "get current settings error,please check logs"
  151. show_menu
  152. fi
  153. LOGI "${info}"
  154. }
  155. set_port() {
  156. echo && echo -n -e "Enter port number[1-65535]: " && read port
  157. if [[ -z "${port}" ]]; then
  158. LOGD "Cancelled"
  159. before_show_menu
  160. else
  161. /usr/local/x-ui/x-ui setting -port ${port}
  162. echo -e "The port is set,Please restart the panel now,and use the new port ${green}${port}${plain} to access web panel"
  163. confirm_restart
  164. fi
  165. }
  166. start() {
  167. check_status
  168. if [[ $? == 0 ]]; then
  169. echo ""
  170. LOGI "Panel is running,No need to start again,If you need to restart, please select restart"
  171. else
  172. systemctl start x-ui
  173. sleep 2
  174. check_status
  175. if [[ $? == 0 ]]; then
  176. LOGI "x-ui Started Successfully"
  177. else
  178. LOGE "panel Failed to start,Probably because it takes longer than two seconds to start,Please check the log information later"
  179. fi
  180. fi
  181. if [[ $# == 0 ]]; then
  182. before_show_menu
  183. fi
  184. }
  185. stop() {
  186. check_status
  187. if [[ $? == 1 ]]; then
  188. echo ""
  189. LOGI "Panel stopped,No need to stop again!"
  190. else
  191. systemctl stop x-ui
  192. sleep 2
  193. check_status
  194. if [[ $? == 1 ]]; then
  195. LOGI "x-ui and xray stopped successfully"
  196. else
  197. LOGE "Panel stop failed,Probably because the stop time exceeds two seconds,Please check the log information later"
  198. fi
  199. fi
  200. if [[ $# == 0 ]]; then
  201. before_show_menu
  202. fi
  203. }
  204. restart() {
  205. systemctl restart x-ui
  206. sleep 2
  207. check_status
  208. if [[ $? == 0 ]]; then
  209. LOGI "x-ui and xray Restarted successfully"
  210. else
  211. LOGE "Panel restart failed,Probably because it takes longer than two seconds to start,Please check the log information later"
  212. fi
  213. if [[ $# == 0 ]]; then
  214. before_show_menu
  215. fi
  216. }
  217. status() {
  218. systemctl status x-ui -l
  219. if [[ $# == 0 ]]; then
  220. before_show_menu
  221. fi
  222. }
  223. enable() {
  224. systemctl enable x-ui
  225. if [[ $? == 0 ]]; then
  226. LOGI "x-ui Set to boot automatically on startup successfully"
  227. else
  228. LOGE "x-ui Failed to set Autostart"
  229. fi
  230. if [[ $# == 0 ]]; then
  231. before_show_menu
  232. fi
  233. }
  234. disable() {
  235. systemctl disable x-ui
  236. if [[ $? == 0 ]]; then
  237. LOGI "x-ui Autostart Cancelled successfully"
  238. else
  239. LOGE "x-ui Failed to cancel autostart"
  240. fi
  241. if [[ $# == 0 ]]; then
  242. before_show_menu
  243. fi
  244. }
  245. show_log() {
  246. journalctl -u x-ui.service -e --no-pager -f
  247. if [[ $# == 0 ]]; then
  248. before_show_menu
  249. fi
  250. }
  251. enable_bbr() {
  252. if grep -q "net.core.default_qdisc=fq" /etc/sysctl.conf && grep -q "net.ipv4.tcp_congestion_control=bbr" /etc/sysctl.conf; then
  253. echo -e "${green}BBR is already enabled!${plain}"
  254. exit 0
  255. fi
  256. # Check the OS and install necessary packages
  257. if [[ "$(cat /etc/os-release | grep -E '^ID=' | awk -F '=' '{print $2}')" == "ubuntu" ]]; then
  258. sudo apt-get update && sudo apt-get install -yqq --no-install-recommends ca-certificates
  259. elif [[ "$(cat /etc/os-release | grep -E '^ID=' | awk -F '=' '{print $2}')" == "debian" ]]; then
  260. sudo apt-get update && sudo apt-get install -yqq --no-install-recommends ca-certificates
  261. elif [[ "$(cat /etc/os-release | grep -E '^ID=' | awk -F '=' '{print $2}')" == "fedora" ]]; then
  262. sudo dnf -y update && sudo dnf -y install ca-certificates
  263. elif [[ "$(cat /etc/os-release | grep -E '^ID=' | awk -F '=' '{print $2}')" == "centos" ]]; then
  264. sudo yum -y update && sudo yum -y install ca-certificates
  265. else
  266. echo "Unsupported operating system. Please check the script and install the necessary packages manually."
  267. exit 1
  268. fi
  269. # Enable BBR
  270. echo "net.core.default_qdisc=fq" | sudo tee -a /etc/sysctl.conf
  271. echo "net.ipv4.tcp_congestion_control=bbr" | sudo tee -a /etc/sysctl.conf
  272. # Apply changes
  273. sudo sysctl -p
  274. # Verify that BBR is enabled
  275. if [[ $(sysctl net.ipv4.tcp_congestion_control | awk '{print $3}') == "bbr" ]]; then
  276. echo -e "${green}BBR has been enabled successfully.${plain}"
  277. else
  278. echo -e "${red}Failed to enable BBR. Please check your system configuration.${plain}"
  279. fi
  280. }
  281. update_shell() {
  282. wget -O /usr/bin/x-ui -N --no-check-certificate https://github.com/MHSanaei/3x-ui/raw/main/x-ui.sh
  283. if [[ $? != 0 ]]; then
  284. echo ""
  285. LOGE "Failed to download script,Please check whether the machine can connect Github"
  286. before_show_menu
  287. else
  288. chmod +x /usr/bin/x-ui
  289. LOGI "Upgrade script succeeded,Please rerun the script" && exit 0
  290. fi
  291. }
  292. # 0: running, 1: not running, 2: not installed
  293. check_status() {
  294. if [[ ! -f /etc/systemd/system/x-ui.service ]]; then
  295. return 2
  296. fi
  297. temp=$(systemctl status x-ui | grep Active | awk '{print $3}' | cut -d "(" -f2 | cut -d ")" -f1)
  298. if [[ x"${temp}" == x"running" ]]; then
  299. return 0
  300. else
  301. return 1
  302. fi
  303. }
  304. check_enabled() {
  305. temp=$(systemctl is-enabled x-ui)
  306. if [[ x"${temp}" == x"enabled" ]]; then
  307. return 0
  308. else
  309. return 1
  310. fi
  311. }
  312. check_uninstall() {
  313. check_status
  314. if [[ $? != 2 ]]; then
  315. echo ""
  316. LOGE "Panel installed,Please do not reinstall"
  317. if [[ $# == 0 ]]; then
  318. before_show_menu
  319. fi
  320. return 1
  321. else
  322. return 0
  323. fi
  324. }
  325. check_install() {
  326. check_status
  327. if [[ $? == 2 ]]; then
  328. echo ""
  329. LOGE "Please install the panel first"
  330. if [[ $# == 0 ]]; then
  331. before_show_menu
  332. fi
  333. return 1
  334. else
  335. return 0
  336. fi
  337. }
  338. show_status() {
  339. check_status
  340. case $? in
  341. 0)
  342. echo -e "Panel state: ${green}Running${plain}"
  343. show_enable_status
  344. ;;
  345. 1)
  346. echo -e "Panel state: ${yellow}Not Running${plain}"
  347. show_enable_status
  348. ;;
  349. 2)
  350. echo -e "Panel state: ${red}Not Installed${plain}"
  351. ;;
  352. esac
  353. show_xray_status
  354. }
  355. show_enable_status() {
  356. check_enabled
  357. if [[ $? == 0 ]]; then
  358. echo -e "Start automatically: ${green}Yes${plain}"
  359. else
  360. echo -e "Start automatically: ${red}No${plain}"
  361. fi
  362. }
  363. check_xray_status() {
  364. count=$(ps -ef | grep "xray-linux" | grep -v "grep" | wc -l)
  365. if [[ count -ne 0 ]]; then
  366. return 0
  367. else
  368. return 1
  369. fi
  370. }
  371. show_xray_status() {
  372. check_xray_status
  373. if [[ $? == 0 ]]; then
  374. echo -e "xray state: ${green}Running${plain}"
  375. else
  376. echo -e "xray state: ${red}Not Running${plain}"
  377. fi
  378. }
  379. #this will be an entrance for ssl cert issue
  380. #here we can provide two different methods to issue cert
  381. #first.standalone mode second.DNS API mode
  382. ssl_cert_issue() {
  383. local method=""
  384. echo -E ""
  385. LOGD "********Usage********"
  386. LOGI "this shell script will use acme to help issue certs."
  387. LOGI "here we provide two methods for issuing certs:"
  388. LOGI "method 1:acme standalone mode,need to keep port:80 open"
  389. LOGI "method 2:acme DNS API mode,need provide Cloudflare Global API Key"
  390. LOGI "recommend method 2 first,if it fails,you can try method 1."
  391. LOGI "certs will be installed in /root/cert directory"
  392. read -p "please choose which method do you want,type 1 or 2": method
  393. LOGI "you choosed method:${method}"
  394. if [ "${method}" == "1" ]; then
  395. ssl_cert_issue_standalone
  396. elif [ "${method}" == "2" ]; then
  397. ssl_cert_issue_by_cloudflare
  398. else
  399. LOGE "invalid input,please check it..."
  400. exit 1
  401. fi
  402. }
  403. install_acme() {
  404. cd ~
  405. LOGI "install acme..."
  406. curl https://get.acme.sh | sh
  407. if [ $? -ne 0 ]; then
  408. LOGE "install acme failed"
  409. return 1
  410. else
  411. LOGI "install acme succeed"
  412. fi
  413. return 0
  414. }
  415. #method for standalone mode
  416. ssl_cert_issue_standalone() {
  417. #check for acme.sh first
  418. if ! command -v ~/.acme.sh/acme.sh &>/dev/null; then
  419. echo "acme.sh could not be found. we will install it"
  420. install_acme
  421. if [ $? -ne 0 ]; then
  422. LOGE "install acme failed, please check logs"
  423. exit 1
  424. fi
  425. fi
  426. #install socat second
  427. if [[ x"${release}" == x"centos" ]]; then
  428. yum install socat -y
  429. else
  430. apt install socat -y
  431. fi
  432. if [ $? -ne 0 ]; then
  433. LOGE "install socat failed,please check logs"
  434. exit 1
  435. else
  436. LOGI "install socat succeed..."
  437. fi
  438. #creat a directory for install cert
  439. certPath=/root/cert
  440. if [ ! -d "$certPath" ]; then
  441. mkdir $certPath
  442. else
  443. rm -rf $certPath
  444. mkdir $certPath
  445. fi
  446. #get the domain here,and we need verify it
  447. local domain=""
  448. read -p "please input your domain:" domain
  449. LOGD "your domain is:${domain},check it..."
  450. #here we need to judge whether there exists cert already
  451. local currentCert=$(~/.acme.sh/acme.sh --list | tail -1 | awk '{print $1}')
  452. if [ ${currentCert} == ${domain} ]; then
  453. local certInfo=$(~/.acme.sh/acme.sh --list)
  454. LOGE "system already have certs here,can not issue again,current certs details:"
  455. LOGI "$certInfo"
  456. exit 1
  457. else
  458. LOGI "your domain is ready for issuing cert now..."
  459. fi
  460. #get needed port here
  461. local WebPort=80
  462. read -p "please choose which port do you use,default will be 80 port:" WebPort
  463. if [[ ${WebPort} -gt 65535 || ${WebPort} -lt 1 ]]; then
  464. LOGE "your input ${WebPort} is invalid,will use default port"
  465. fi
  466. LOGI "will use port:${WebPort} to issue certs,please make sure this port is open..."
  467. #NOTE:This should be handled by user
  468. #open the port and kill the occupied progress
  469. ~/.acme.sh/acme.sh --set-default-ca --server letsencrypt
  470. ~/.acme.sh/acme.sh --issue -d ${domain} --standalone --httpport ${WebPort}
  471. if [ $? -ne 0 ]; then
  472. LOGE "issue certs failed,please check logs"
  473. rm -rf ~/.acme.sh/${domain}
  474. exit 1
  475. else
  476. LOGE "issue certs succeed,installing certs..."
  477. fi
  478. #install cert
  479. ~/.acme.sh/acme.sh --installcert -d ${domain} --ca-file /root/cert/ca.cer \
  480. --cert-file /root/cert/${domain}.cer --key-file /root/cert/${domain}.key \
  481. --fullchain-file /root/cert/fullchain.cer
  482. if [ $? -ne 0 ]; then
  483. LOGE "install certs failed,exit"
  484. rm -rf ~/.acme.sh/${domain}
  485. exit 1
  486. else
  487. LOGI "install certs succeed,enable auto renew..."
  488. fi
  489. ~/.acme.sh/acme.sh --upgrade --auto-upgrade
  490. if [ $? -ne 0 ]; then
  491. LOGE "auto renew failed,certs details:"
  492. ls -lah cert
  493. chmod 755 $certPath
  494. exit 1
  495. else
  496. LOGI "auto renew succeed,certs details:"
  497. ls -lah cert
  498. chmod 755 $certPath
  499. fi
  500. }
  501. #method for DNS API mode
  502. ssl_cert_issue_by_cloudflare() {
  503. echo -E ""
  504. LOGD "******Preconditions******"
  505. LOGI "1.need Cloudflare account associated email"
  506. LOGI "2.need Cloudflare Global API Key"
  507. LOGI "3.your domain use Cloudflare as resolver"
  508. confirm "I have confirmed all these info above[y/n]" "y"
  509. if [ $? -eq 0 ]; then
  510. install_acme
  511. if [ $? -ne 0 ]; then
  512. LOGE "install acme failed,please check logs"
  513. exit 1
  514. fi
  515. CF_Domain=""
  516. CF_GlobalKey=""
  517. CF_AccountEmail=""
  518. certPath=/root/cert
  519. if [ ! -d "$certPath" ]; then
  520. mkdir $certPath
  521. else
  522. rm -rf $certPath
  523. mkdir $certPath
  524. fi
  525. LOGD "please input your domain:"
  526. read -p "Input your domain here:" CF_Domain
  527. LOGD "your domain is:${CF_Domain},check it..."
  528. #here we need to judge whether there exists cert already
  529. local currentCert=$(~/.acme.sh/acme.sh --list | tail -1 | awk '{print $1}')
  530. if [ ${currentCert} == ${CF_Domain} ]; then
  531. local certInfo=$(~/.acme.sh/acme.sh --list)
  532. LOGE "system already have certs here,can not issue again,current certs details:"
  533. LOGI "$certInfo"
  534. exit 1
  535. else
  536. LOGI "your domain is ready for issuing cert now..."
  537. fi
  538. LOGD "please inout your cloudflare global API key:"
  539. read -p "Input your key here:" CF_GlobalKey
  540. LOGD "your cloudflare global API key is:${CF_GlobalKey}"
  541. LOGD "please input your cloudflare account email:"
  542. read -p "Input your email here:" CF_AccountEmail
  543. LOGD "your cloudflare account email:${CF_AccountEmail}"
  544. ~/.acme.sh/acme.sh --set-default-ca --server letsencrypt
  545. if [ $? -ne 0 ]; then
  546. LOGE "change the default CA to Lets'Encrypt failed,exit"
  547. exit 1
  548. fi
  549. export CF_Key="${CF_GlobalKey}"
  550. export CF_Email=${CF_AccountEmail}
  551. ~/.acme.sh/acme.sh --issue --dns dns_cf -d ${CF_Domain} -d *.${CF_Domain} --log
  552. if [ $? -ne 0 ]; then
  553. LOGE "issue cert failed,exit"
  554. rm -rf ~/.acme.sh/${CF_Domain}
  555. exit 1
  556. else
  557. LOGI "Certificate issued Successfully, Installing..."
  558. fi
  559. ~/.acme.sh/acme.sh --installcert -d ${CF_Domain} -d *.${CF_Domain} --ca-file /root/cert/ca.cer \
  560. --cert-file /root/cert/${CF_Domain}.cer --key-file /root/cert/${CF_Domain}.key \
  561. --fullchain-file /root/cert/fullchain.cer
  562. if [ $? -ne 0 ]; then
  563. LOGE "install cert failed,exit"
  564. rm -rf ~/.acme.sh/${CF_Domain}
  565. exit 1
  566. else
  567. LOGI "Certificate installed Successfully,Turning on automatic updates..."
  568. fi
  569. ~/.acme.sh/acme.sh --upgrade --auto-upgrade
  570. if [ $? -ne 0 ]; then
  571. LOGE "Auto update setup Failed, script exiting..."
  572. ls -lah cert
  573. chmod 755 $certPath
  574. exit 1
  575. else
  576. LOGI "The certificate is installed and auto-renewal is turned on, Specific information is as follows"
  577. ls -lah cert
  578. chmod 755 $certPath
  579. fi
  580. else
  581. show_menu
  582. fi
  583. }
  584. show_usage() {
  585. echo "x-ui control menu usages: "
  586. echo "------------------------------------------"
  587. echo -e "x-ui - Enter control menu"
  588. echo -e "x-ui start - Start x-ui "
  589. echo -e "x-ui stop - Stop x-ui "
  590. echo -e "x-ui restart - Restart x-ui "
  591. echo -e "x-ui status - Show x-ui status"
  592. echo -e "x-ui enable - Enable x-ui on system startup"
  593. echo -e "x-ui disable - Disable x-ui on system startup"
  594. echo -e "x-ui log - Check x-ui logs"
  595. echo -e "x-ui update - Update x-ui "
  596. echo -e "x-ui install - Install x-ui "
  597. echo -e "x-ui uninstall - Uninstall x-ui "
  598. echo "------------------------------------------"
  599. }
  600. show_menu() {
  601. echo -e "
  602. ${green}3X-ui Panel Management Script${plain}
  603. ${green}0.${plain} Exit Script
  604. ————————————————
  605. ${green}1.${plain} Install x-ui
  606. ${green}2.${plain} Update x-ui
  607. ${green}3.${plain} Uninstall x-ui
  608. ————————————————
  609. ${green}4.${plain} Reset Username And Password
  610. ${green}5.${plain} Reset Panel Settings
  611. ${green}6.${plain} Change Panel Port
  612. ${green}7.${plain} View Current Panel Settings
  613. ————————————————
  614. ${green}8.${plain} Start x-ui
  615. ${green}9.${plain} Stop x-ui
  616. ${green}10.${plain} Restart x-ui
  617. ${green}11.${plain} Check x-ui Status
  618. ${green}12.${plain} Check x-ui Logs
  619. ————————————————
  620. ${green}13.${plain} Enable x-ui On System Startup
  621. ${green}14.${plain} Disabel x-ui On System Startup
  622. ————————————————
  623. ${green}15.${plain} Enable BBR
  624. ${green}16.${plain} Issuse Certs
  625. "
  626. show_status
  627. echo && read -p "Please enter your selection [0-16]: " num
  628. case "${num}" in
  629. 0)
  630. exit 0
  631. ;;
  632. 1)
  633. check_uninstall && install
  634. ;;
  635. 2)
  636. check_install && update
  637. ;;
  638. 3)
  639. check_install && uninstall
  640. ;;
  641. 4)
  642. check_install && reset_user
  643. ;;
  644. 5)
  645. check_install && reset_config
  646. ;;
  647. 6)
  648. check_install && set_port
  649. ;;
  650. 7)
  651. check_install && check_config
  652. ;;
  653. 8)
  654. check_install && start
  655. ;;
  656. 9)
  657. check_install && stop
  658. ;;
  659. 10)
  660. check_install && restart
  661. ;;
  662. 11)
  663. check_install && status
  664. ;;
  665. 12)
  666. check_install && show_log
  667. ;;
  668. 13)
  669. check_install && enable
  670. ;;
  671. 14)
  672. check_install && disable
  673. ;;
  674. 15)
  675. enable_bbr
  676. ;;
  677. 16)
  678. ssl_cert_issue
  679. ;;
  680. *)
  681. LOGE "Please enter the correct number [0-16]"
  682. ;;
  683. esac
  684. }
  685. if [[ $# > 0 ]]; then
  686. case $1 in
  687. "start")
  688. check_install 0 && start 0
  689. ;;
  690. "stop")
  691. check_install 0 && stop 0
  692. ;;
  693. "restart")
  694. check_install 0 && restart 0
  695. ;;
  696. "status")
  697. check_install 0 && status 0
  698. ;;
  699. "enable")
  700. check_install 0 && enable 0
  701. ;;
  702. "disable")
  703. check_install 0 && disable 0
  704. ;;
  705. "log")
  706. check_install 0 && show_log 0
  707. ;;
  708. "update")
  709. check_install 0 && update 0
  710. ;;
  711. "install")
  712. check_uninstall 0 && install 0
  713. ;;
  714. "uninstall")
  715. check_install 0 && uninstall 0
  716. ;;
  717. *) show_usage ;;
  718. esac
  719. else
  720. show_menu
  721. fi